<?php

namespace Teknisa\CADFIS\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Geral\Logic\ParceiroNegocio;
use Teknisa\CADFIS\Controllers\TeknisaCrud;
use Teknisa\CADFIS\Services\Ger05500ProdutosDesoneracaoImpostosService;

class Ger05500ProdutosDesoneracaoImpostosController extends TeknisaCrud {
    protected $dataSourceName;

    public function __construct($crudService, $parameterBag, Ger05500ProdutosDesoneracaoImpostosService $service) {
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $dataSource = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()));
        $this->dataSourceName = $dataSource;
        parent::find($request, $response);
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        $dataSource = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()) - 6);
        $this->dataSourceName = $dataSource;
        parent::save($request, $response);
    }

    public function delete(DTO\Request $request, DTO\Response $response) {
        $dataSource = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()) - 8);
        $this->dataSourceName = $dataSource;
        parent::delete($request, $response);
    }

    public function deleteProdutosDesoneracao(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $this->service->deleteProdutosDesoneracao($request->getRow());
        }
        catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
}