<?php

namespace Teknisa\CADFIS\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\CADFIS\Factories\Dfs47000ValorMaximoVendaConsumidorFactory;
use Zeedhi\Framework\DTO\Response;

class Dfs47000ValorMaximoVendaConsumidorService {

    public function __construct($entityManager, $environment, Dfs47000ValorMaximoVendaConsumidorFactory $Dfs47000ValorMaximoVendaConsumidorFactory) {
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->Dfs47000ValorMaximoVendaConsumidorFactory = $Dfs47000ValorMaximoVendaConsumidorFactory;
        $this->nrorg = $this->environment->getNrOrgTrab();
    } 
    
    public function saveVRMAXVENPROD($row){
        try{
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $existeVRMAXVENPROD = $this->Dfs47000ValorMaximoVendaConsumidorFactory->selectVRMAXVENPROD($row['CDPRODUTO'], $row['CDPAIS'], $row['SGESTADO'], $row['NRORG']);
            
            if ($existeVRMAXVENPROD){
                $return = $this->Dfs47000ValorMaximoVendaConsumidorFactory->updateVRMAXVENPROD($row['IDUTILVRMAX'], $row['VRDESCMAXVENDA'], $row['VRMAXVENDA'], $row['VRPEMAXVENDA'], $row['CDPRODUTO'], $row['CDPAIS'], $row['SGESTADO'], $row['NRORG']);
                $connection->commit();
                return $return;
            } else {
                $return = $this->Dfs47000ValorMaximoVendaConsumidorFactory->insertVRMAXVENPROD($row['IDUTILVRMAX'], $row['VRDESCMAXVENDA'], $row['VRMAXVENDA'], $row['VRPEMAXVENDA'], $row['CDPRODUTO'], $row['CDPAIS'], $row['SGESTADO'], $row['NRORG']);
                $connection->commit();
                return $return;
            }
            
        }catch(\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function replicacaoValorMax($row, $response){
        try{
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $row['NRORG'] = $this->nrorg;
            $selectPROD = $this->Dfs47000ValorMaximoVendaConsumidorFactory->selectVRMAXVENPROD_PROD($row['CDPAIS_ORIG'], $row['SGESTADO_ORIG'], $row['NRORG']);
            
            if ($selectPROD){
                foreach ($selectPROD as $orig){
                    $existeDest = $this->Dfs47000ValorMaximoVendaConsumidorFactory->selectVRMAXVENPROD($orig['CDPRODUTO'], $row['CDPAIS_DEST'], $row['SGESTADO_DEST'], $row['NRORG']);
                    if($existeDest){
                        $this->Dfs47000ValorMaximoVendaConsumidorFactory->updateVRMAXVENPROD($orig['IDUTILVRMAX'], $orig['VRDESCMAXVENDA'], $orig['VRMAXVENDA'], $orig['VRPEMAXVENDA'], $orig['CDPRODUTO'], $row['CDPAIS_DEST'], $row['SGESTADO_DEST'], $row['NRORG']);
                    } else {
                        $this->Dfs47000ValorMaximoVendaConsumidorFactory->insertVRMAXVENPROD($orig['IDUTILVRMAX'], $orig['VRDESCMAXVENDA'], $orig['VRMAXVENDA'], $orig['VRPEMAXVENDA'], $orig['CDPRODUTO'], $row['CDPAIS_DEST'], $row['SGESTADO_DEST'], $row['NRORG']);
                    }
                }
                
                $connection->commit();
                return true;
            } else {
                $array = [
                    "ESTADO"=>$row['SGESTADO_ORIG'], 
                    "PAIS"=>$row['CDPAIS_ORIG']
                ];
                $response->setError(new Response\Error($array, 500));
            }
        }catch(\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function cadastramentoAutomatico($row){
        try{
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $row['NRORG'] = $this->nrorg;
            $selectProd = $this->Dfs47000ValorMaximoVendaConsumidorFactory->selectProdCadastAutom($row);

            if ($selectProd){
                foreach ($selectProd as $produto){
                    $existeVRMAXVENPROD = $this->Dfs47000ValorMaximoVendaConsumidorFactory->selectVRMAXVENPROD($produto['CDPRODUTO'], $row['CDPAIS'], $row['SGESTADO'], $row['NRORG']);
                    if($existeVRMAXVENPROD){
                        $this->Dfs47000ValorMaximoVendaConsumidorFactory->updateVRMAXVENPROD($row['IDUTILVRMAX'], $row['VRDESCMAXVENDA'], $row['VRMAXVENDA'], $row['VRPEMAXVENDA'], $produto['CDPRODUTO'], $row['CDPAIS'], $row['SGESTADO'], $row['NRORG']);
                    } else {
                        $this->Dfs47000ValorMaximoVendaConsumidorFactory->insertVRMAXVENPROD($row['IDUTILVRMAX'], $row['VRDESCMAXVENDA'], $row['VRMAXVENDA'], $row['VRPEMAXVENDA'], $produto['CDPRODUTO'], $row['CDPAIS'], $row['SGESTADO'], $row['NRORG']);
                    }
                }
                
                $connection->commit();
                return true;
            } else {
               throw new \Exception('Ocorreu um erro ao realizar o cadastro automatico.');
            }
        }catch(\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
}